import json
import os
import tempfile
import pytest
import brian_dashboard_manager


@pytest.fixture
def data_config():
    return {
        "admin_username": "admin",
        "admin_password": "admin",
        "hostname": "localhost",
        "listen_port": 3001,
        "grafana_port": 3000,
        "organizations": ['Testorg1', 'GÉANT Testorg2', 'NRENsTestorg3', 'General Public'],
        "BRIAN_ENVIRONMENT": "test"
    }


@pytest.fixture
def data_config_filename(data_config):
    with tempfile.NamedTemporaryFile() as f:
        f.write(json.dumps(data_config).encode('utf-8'))
        f.flush()
        yield f.name


@pytest.fixture
def client(data_config_filename):
    os.environ['SETTINGS_FILENAME'] = data_config_filename
    with brian_dashboard_manager.create_app().test_client() as c:
        yield c
